//***********************************************************************************************************
//Criação das funções de controle
//***********************************************************************************************************

void sendMessage();
String getReadings();

//Criação da tarefa de leitura e escrita de mensagens
Task taskSendMessage(TASK_SECOND * 1 , TASK_FOREVER, &sendMessage);

//Montagem da mensagem que será enviada para a rede Mesh
//No exemplo será transmitido o número do nó que está enviando a mensagem
//e o valor da leitura da entrada digital X1
String getReadings () {
  JSONVar jsonReadings;
  jsonReadings["node"] = nodeNumber;
  jsonReadings["dig"] = !digitalRead(pin_X1);
  readings = JSON.stringify(jsonReadings);
  return readings;
}

//Função para envio da mensagem consolidada
void sendMessage () {
  String msg = getReadings();
  mesh.sendBroadcast(msg);
}

//Função de recebimento das mensagens que trafegam na rede
//Retira do arquivo de cada mensagem o número do nó que enviou
//e o valor da entrada digital do mesmo
//Depois imprime na serial USB para verificação
void receivedCallback( uint32_t from, String &msg ) {
  JSONVar myObject = JSON.parse(msg.c_str());
  int node = myObject["node"];
  bool dig = myObject["dig"];
  Serial.print("Node: ");
  Serial.println(node);
  Serial.print("Digital: ");
  Serial.println(dig);
}

//Função que retorna na serial as novas conexões estabelecidas
void newConnectionCallback(uint32_t nodeId) {
  Serial.printf("New Connection, nodeId = %u\n", nodeId);
}

//Função que retorna na serial as mudanças nas conexões estabelecidas
void changedConnectionCallback() {
  Serial.printf("Changed connections\n");
}

//Função que retorna na serial mudança no tempo de latência da rede
void nodeTimeAdjustedCallback(int32_t offset) {
  Serial.printf("Adjusted time %u. Offset = %d\n", mesh.getNodeTime(),offset);
}
