//Software exemplo para implementação de uma rede Mesh
//O pacote de dados a ser trafegado será um JSON
//Alterar o nodeNumber de cada equipamento na rede

//Inclusão das bibliotecas
//Caso seja necessário instalar a biblioteca AsyncTCP-master que se encontra na pasta do programa
//É preciso instalar a biblioteca em "Ferramentas/Gerenciar Bibliotecas..."
#include "painlessMesh.h"     //Biblioteca responsável pela rede mesh
#include <Arduino_JSON.h>     //Biblioteca responsável pela montagem do pacote JSON

//Entrada digital
#define pin_X1 15

//Configuração da rede Wifi
#define   MESH_PREFIX     "RNTMESH"         //Nome da rede Mesh (deve ser igual para todos os nós)
#define   MESH_PASSWORD   "MESHpassword"    //Senha para a rede Mesh (deve ser igual para todos os nós)
#define   MESH_PORT       5555              //Porta de comunicação padrão

//Número do do equipamento na rede
//Esse número tem que ser diferente para cada equipamento na rede
int nodeNumber = 1;

//String que irá conter a mensagem a ser enviada
String readings;

//Estrutura de controle da tarefa
Scheduler userScheduler;
//Nomeação da estrutura da rede
painlessMesh  mesh;

//Inclusão das funções de controle
#include "Func_Ctrl.h"

void setup() {
  
  //Inicia serial USB
  Serial.begin(115200);

  //Inicia entrada digital
  pinMode(pin_X1, INPUT);

  //Abaixo todas os tipos de debug disponíveis e a inicialização do debug
  //mesh.setDebugMsgTypes( ERROR | MESH_STATUS | CONNECTION | SYNC | COMMUNICATION | GENERAL | MSG_TYPES | REMOTE ); // all types on
  mesh.setDebugMsgTypes( ERROR | STARTUP );

  //Inicia as funções a serem utilizadas
  mesh.init( MESH_PREFIX, MESH_PASSWORD, &userScheduler, MESH_PORT );
  mesh.onReceive(&receivedCallback);
  //mesh.onNewConnection(&newConnectionCallback);
  //mesh.onChangedConnections(&changedConnectionCallback);
  //mesh.onNodeTimeAdjusted(&nodeTimeAdjustedCallback);
  userScheduler.addTask(taskSendMessage);
  taskSendMessage.enable();
  
}

void loop() {
  
  //Executa a comunicação na rede
  mesh.update();
  
}
